# SwaggerClient

## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 

This ObjC package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 
- Build package: io.swagger.codegen.languages.ObjcClientCodegen
For more information, please visit [https://github.com/uJhin](https://github.com/uJhin)

## Requirements

The SDK requires [**ARC (Automatic Reference Counting)**](http://stackoverflow.com/questions/7778356/how-to-enable-disable-automatic-reference-counting) to be enabled in the Xcode project.

## Installation & Usage
### Install from Github using [CocoaPods](https://cocoapods.org/)

Add the following to the Podfile:

```ruby
pod 'SwaggerClient', :git => 'https://github.com//.git'
```

To specify a particular branch, append `, :branch => 'branch-name-here'`

To specify a particular commit, append `, :commit => '11aa22'`

### Install from local path using [CocoaPods](https://cocoapods.org/)

Put the SDK under your project folder (e.g. /path/to/objc_project/Vendor/SwaggerClient) and then add the following to the Podfile:

```ruby
pod 'SwaggerClient', :path => 'Vendor/SwaggerClient'
```

### Usage

Import the following:

```objc
#import <SwaggerClient/SWGApiClient.h>
#import <SwaggerClient/SWGDefaultConfiguration.h>
// load models
#import <SwaggerClient/SWGAPIKey.h>
#import <SwaggerClient/SWGAccount.h>
#import <SwaggerClient/SWGAsk.h>
#import <SwaggerClient/SWGAskAccount.h>
#import <SwaggerClient/SWGBid.h>
#import <SwaggerClient/SWGBidAccount.h>
#import <SwaggerClient/SWGCandleDate.h>
#import <SwaggerClient/SWGCandleDays.h>
#import <SwaggerClient/SWGCandleMinutes.h>
#import <SwaggerClient/SWGCurrency.h>
#import <SwaggerClient/SWGDeposit.h>
#import <SwaggerClient/SWGDepositCompleteResponse.h>
#import <SwaggerClient/SWGDepositTransferResponse.h>
#import <SwaggerClient/SWGError.h>
#import <SwaggerClient/SWGErrorInfo.h>
#import <SwaggerClient/SWGMarket.h>
#import <SwaggerClient/SWGMarketInfo.h>
#import <SwaggerClient/SWGMemberLevel.h>
#import <SwaggerClient/SWGNewOrder.h>
#import <SwaggerClient/SWGOrder.h>
#import <SwaggerClient/SWGOrderChance.h>
#import <SwaggerClient/SWGOrderInfo.h>
#import <SwaggerClient/SWGOrderbook.h>
#import <SwaggerClient/SWGOrderbookUnit.h>
#import <SwaggerClient/SWGTicker.h>
#import <SwaggerClient/SWGTrade.h>
#import <SwaggerClient/SWGTradeTicks.h>
#import <SwaggerClient/SWGWallet.h>
#import <SwaggerClient/SWGWithdraw.h>
#import <SwaggerClient/SWGWithdrawChance.h>
#import <SwaggerClient/SWGWithdrawCoin.h>
#import <SwaggerClient/SWGWithdrawLimit.h>
// load API classes for accessing endpoints
#import <SwaggerClient/SWGAPIKeyApi.h>
#import <SwaggerClient/SWGAccountApi.h>
#import <SwaggerClient/SWGCandleApi.h>
#import <SwaggerClient/SWGDepositApi.h>
#import <SwaggerClient/SWGMarketApi.h>
#import <SwaggerClient/SWGOrderApi.h>
#import <SwaggerClient/SWGTradeApi.h>
#import <SwaggerClient/SWGWithdrawApi.h>

```

## Recommendation

It's recommended to create an instance of ApiClient per thread in a multi-threaded environment to avoid any potential issues.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```objc

SWGDefaultConfiguration *apiConfig = [SWGDefaultConfiguration sharedConfig];

// Configure API key authorization: (authentication scheme: Bearer)
[apiConfig setApiKey:@"YOUR_API_KEY" forApiKeyIdentifier:@"Authorization"];
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
//[apiConfig setApiKeyPrefix:@"Bearer" forApiKeyIdentifier:@"Authorization"];



SWGAPIKeyApi *apiInstance = [[SWGAPIKeyApi alloc] init];

// API 키 리스트 조회
[apiInstance aPIKeyInfoWithCompletionHandler: 
              ^(NSArray<SWGAPIKey>* output, NSError* error) {
                            if (output) {
                                NSLog(@"%@", output);
                            }
                            if (error) {
                                NSLog(@"Error: %@", error);
                            }
                        }];

```

## Documentation for API Endpoints

All URIs are relative to *https://api.upbit.com/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*SWGAPIKeyApi* | [**aPIKeyInfo**](docs/SWGAPIKeyApi.md#apikeyinfo) | **GET** /api_keys | API 키 리스트 조회
*SWGAccountApi* | [**accountInfo**](docs/SWGAccountApi.md#accountinfo) | **GET** /accounts | 전체 계좌 조회
*SWGAccountApi* | [**accountWallet**](docs/SWGAccountApi.md#accountwallet) | **GET** /status/wallet | 입출금 현황
*SWGCandleApi* | [**candleDays**](docs/SWGCandleApi.md#candledays) | **GET** /candles/days | 시세 캔들 조회 (일 단위)
*SWGCandleApi* | [**candleMinutes**](docs/SWGCandleApi.md#candleminutes) | **GET** /candles/minutes/{unit} | 시세 캔들 조회 (분 단위)
*SWGCandleApi* | [**candleMonth**](docs/SWGCandleApi.md#candlemonth) | **GET** /candles/months | 시세 캔들 조회 (월 단위)
*SWGCandleApi* | [**candleWeeks**](docs/SWGCandleApi.md#candleweeks) | **GET** /candles/weeks | 시세 캔들 조회 (주 단위)
*SWGDepositApi* | [**depositCoinAddress**](docs/SWGDepositApi.md#depositcoinaddress) | **GET** /deposits/coin_address | 개별 입금 주소 조회
*SWGDepositApi* | [**depositCoinAddresses**](docs/SWGDepositApi.md#depositcoinaddresses) | **GET** /deposits/coin_addresses | 전체 입금 주소 조회
*SWGDepositApi* | [**depositGenerateCoinAddress**](docs/SWGDepositApi.md#depositgeneratecoinaddress) | **POST** /deposits/generate_coin_address | 입금 주소 생성 요청
*SWGDepositApi* | [**depositInfo**](docs/SWGDepositApi.md#depositinfo) | **GET** /deposit | 개별 입금 조회
*SWGDepositApi* | [**depositInfoAll**](docs/SWGDepositApi.md#depositinfoall) | **GET** /deposits | 입금 리스트 조회
*SWGMarketApi* | [**marketInfoAll**](docs/SWGMarketApi.md#marketinfoall) | **GET** /market/all | 마켓 코드 조회
*SWGOrderApi* | [**orderCancel**](docs/SWGOrderApi.md#ordercancel) | **DELETE** /order | 주문 취소 접수
*SWGOrderApi* | [**orderChance**](docs/SWGOrderApi.md#orderchance) | **GET** /orders/chance | 주문 가능 정보
*SWGOrderApi* | [**orderInfo**](docs/SWGOrderApi.md#orderinfo) | **GET** /order | 개별 주문 조회
*SWGOrderApi* | [**orderInfoAll**](docs/SWGOrderApi.md#orderinfoall) | **GET** /orders | 주문 리스트 조회
*SWGOrderApi* | [**orderNew**](docs/SWGOrderApi.md#ordernew) | **POST** /orders | 주문하기
*SWGOrderApi* | [**orderOrderbook**](docs/SWGOrderApi.md#orderorderbook) | **GET** /orderbook | 시세 호가 정보(Orderbook) 조회
*SWGTradeApi* | [**tradeTicker**](docs/SWGTradeApi.md#tradeticker) | **GET** /ticker | 시세 Ticker 조회
*SWGTradeApi* | [**tradeTicks**](docs/SWGTradeApi.md#tradeticks) | **GET** /trades/ticks | 시세 체결 조회
*SWGWithdrawApi* | [**withdrawChance**](docs/SWGWithdrawApi.md#withdrawchance) | **GET** /withdraws/chance | 출금 가능 정보
*SWGWithdrawApi* | [**withdrawCoin**](docs/SWGWithdrawApi.md#withdrawcoin) | **POST** /withdraws/coin | 코인 출금하기
*SWGWithdrawApi* | [**withdrawInfo**](docs/SWGWithdrawApi.md#withdrawinfo) | **GET** /withdraw | 개별 출금 조회
*SWGWithdrawApi* | [**withdrawInfoAll**](docs/SWGWithdrawApi.md#withdrawinfoall) | **GET** /withdraws | 출금 리스트 조회
*SWGWithdrawApi* | [**withdrawKrw**](docs/SWGWithdrawApi.md#withdrawkrw) | **POST** /withdraws/krw | 원화 출금하기


## Documentation For Models

 - [SWGAPIKey](docs/SWGAPIKey.md)
 - [SWGAccount](docs/SWGAccount.md)
 - [SWGAsk](docs/SWGAsk.md)
 - [SWGAskAccount](docs/SWGAskAccount.md)
 - [SWGBid](docs/SWGBid.md)
 - [SWGBidAccount](docs/SWGBidAccount.md)
 - [SWGCandleDate](docs/SWGCandleDate.md)
 - [SWGCandleDays](docs/SWGCandleDays.md)
 - [SWGCandleMinutes](docs/SWGCandleMinutes.md)
 - [SWGCurrency](docs/SWGCurrency.md)
 - [SWGDeposit](docs/SWGDeposit.md)
 - [SWGDepositCompleteResponse](docs/SWGDepositCompleteResponse.md)
 - [SWGDepositTransferResponse](docs/SWGDepositTransferResponse.md)
 - [SWGError](docs/SWGError.md)
 - [SWGErrorInfo](docs/SWGErrorInfo.md)
 - [SWGMarket](docs/SWGMarket.md)
 - [SWGMarketInfo](docs/SWGMarketInfo.md)
 - [SWGMemberLevel](docs/SWGMemberLevel.md)
 - [SWGNewOrder](docs/SWGNewOrder.md)
 - [SWGOrder](docs/SWGOrder.md)
 - [SWGOrderChance](docs/SWGOrderChance.md)
 - [SWGOrderInfo](docs/SWGOrderInfo.md)
 - [SWGOrderbook](docs/SWGOrderbook.md)
 - [SWGOrderbookUnit](docs/SWGOrderbookUnit.md)
 - [SWGTicker](docs/SWGTicker.md)
 - [SWGTrade](docs/SWGTrade.md)
 - [SWGTradeTicks](docs/SWGTradeTicks.md)
 - [SWGWallet](docs/SWGWallet.md)
 - [SWGWithdraw](docs/SWGWithdraw.md)
 - [SWGWithdrawChance](docs/SWGWithdrawChance.md)
 - [SWGWithdrawCoin](docs/SWGWithdrawCoin.md)
 - [SWGWithdrawLimit](docs/SWGWithdrawLimit.md)


## Documentation For Authorization


## Bearer

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header


## Author

ujhin942@gmail.com


