# Upbit Open API
#
# ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
#
# OpenAPI spec version: 1.0.0
# Contact: ujhin942@gmail.com
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' AskAccount Class
#'
#' @field currency 
#' @field balance 
#' @field locked 
#' @field avg_buy_price 
#' @field avg_buy_price_modified 
#' @field unit_currency 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
AskAccount <- R6::R6Class(
  'AskAccount',
  public = list(
    `currency` = NULL,
    `balance` = NULL,
    `locked` = NULL,
    `avg_buy_price` = NULL,
    `avg_buy_price_modified` = NULL,
    `unit_currency` = NULL,
    initialize = function(`currency`, `balance`, `locked`, `avg_buy_price`, `avg_buy_price_modified`, `unit_currency`){
      if (!missing(`currency`)) {
        stopifnot(is.character(`currency`), length(`currency`) == 1)
        self$`currency` <- `currency`
      }
      if (!missing(`balance`)) {
        stopifnot(is.character(`balance`), length(`balance`) == 1)
        self$`balance` <- `balance`
      }
      if (!missing(`locked`)) {
        stopifnot(is.character(`locked`), length(`locked`) == 1)
        self$`locked` <- `locked`
      }
      if (!missing(`avg_buy_price`)) {
        stopifnot(is.character(`avg_buy_price`), length(`avg_buy_price`) == 1)
        self$`avg_buy_price` <- `avg_buy_price`
      }
      if (!missing(`avg_buy_price_modified`)) {
        self$`avg_buy_price_modified` <- `avg_buy_price_modified`
      }
      if (!missing(`unit_currency`)) {
        stopifnot(is.character(`unit_currency`), length(`unit_currency`) == 1)
        self$`unit_currency` <- `unit_currency`
      }
    },
    toJSON = function() {
      AskAccountObject <- list()
      if (!is.null(self$`currency`)) {
        AskAccountObject[['currency']] <- self$`currency`
      }
      if (!is.null(self$`balance`)) {
        AskAccountObject[['balance']] <- self$`balance`
      }
      if (!is.null(self$`locked`)) {
        AskAccountObject[['locked']] <- self$`locked`
      }
      if (!is.null(self$`avg_buy_price`)) {
        AskAccountObject[['avg_buy_price']] <- self$`avg_buy_price`
      }
      if (!is.null(self$`avg_buy_price_modified`)) {
        AskAccountObject[['avg_buy_price_modified']] <- self$`avg_buy_price_modified`
      }
      if (!is.null(self$`unit_currency`)) {
        AskAccountObject[['unit_currency']] <- self$`unit_currency`
      }

      AskAccountObject
    },
    fromJSON = function(AskAccountJson) {
      AskAccountObject <- jsonlite::fromJSON(AskAccountJson)
      if (!is.null(AskAccountObject$`currency`)) {
        self$`currency` <- AskAccountObject$`currency`
      }
      if (!is.null(AskAccountObject$`balance`)) {
        self$`balance` <- AskAccountObject$`balance`
      }
      if (!is.null(AskAccountObject$`locked`)) {
        self$`locked` <- AskAccountObject$`locked`
      }
      if (!is.null(AskAccountObject$`avg_buy_price`)) {
        self$`avg_buy_price` <- AskAccountObject$`avg_buy_price`
      }
      if (!is.null(AskAccountObject$`avg_buy_price_modified`)) {
        self$`avg_buy_price_modified` <- AskAccountObject$`avg_buy_price_modified`
      }
      if (!is.null(AskAccountObject$`unit_currency`)) {
        self$`unit_currency` <- AskAccountObject$`unit_currency`
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "currency": %s,
           "balance": %s,
           "locked": %s,
           "avg_buy_price": %s,
           "avg_buy_price_modified": %s,
           "unit_currency": %s
        }',
        self$`currency`,
        self$`balance`,
        self$`locked`,
        self$`avg_buy_price`,
        self$`avg_buy_price_modified`,
        self$`unit_currency`
      )
    },
    fromJSONString = function(AskAccountJson) {
      AskAccountObject <- jsonlite::fromJSON(AskAccountJson)
      self$`currency` <- AskAccountObject$`currency`
      self$`balance` <- AskAccountObject$`balance`
      self$`locked` <- AskAccountObject$`locked`
      self$`avg_buy_price` <- AskAccountObject$`avg_buy_price`
      self$`avg_buy_price_modified` <- AskAccountObject$`avg_buy_price_modified`
      self$`unit_currency` <- AskAccountObject$`unit_currency`
    }
  )
)
